define(function(require, exports, module) {
    'use strict';
    var Engine      = require('famous/core/Engine');
    var FastClick   = require('famous/inputs/FastClick');
    var MobileView  = require('js/views/MobileView');

    var theme       = require('js/configs/Theme');
    var utils       = require('js/configs/Utils');

    var APP_NAME    = 'slides';
    var APP_PORT    = 8010;

    initMobile();
    initDemobo();
    initApp();

    function initMobile() {
        if (demobo.Utils.isMobile()) {
            if (window.cordova&&cordova.plugins&&cordova.plugins.Keyboard) cordova.plugins.Keyboard.disableScroll(true);
        }
        if (typeof(StatusBar)!="undefined") StatusBar.hide();
        if (navigator.notification) {
            // Override default HTML alert with native dialog
            window.alert = function (message) {
                navigator.notification.alert(
                    message,    // message body
                    null,       // callback
                    "de Mobo Carousel", // title
                    'OK'        // buttonName
                );
            };
        }
    }

    function initDemobo() {
        demobo.init({
            isHost: true,
            isSyncHost: true,
            method: "code",
            code: "1234",
            maxConnections: 1,
            appName: APP_NAME,
            layers: ["websocket:"+APP_PORT],
            port: APP_PORT,
            onSuccess: function() {
            }.bind(this),
            onFailure: function() {
            }.bind(this),
            onPairing: function() {
            }.bind(this),
            onTimeout: function() {
            }.bind(this)
        });
        // wait till demobo is ready, use callback in the future
        demobo.demoboCode = $('<div class="demoboCode"></div>');
        setTimeout(function(){
            if (demobo.Utils.isMobile()) {
                if (utils.checkWifi()) {
                    var ipCode = demobo.discovery.getCodeFromIP(demobo.discovery.getIPAddress());
                    demobo.demoboCode.append('<div class="instruction">Visit www.demobo.com/'+APP_NAME+'<br>Enter Code: <b style="color:'+
                        theme.darkThemeColor+';">' + ipCode.toUpperCase() +'</b></div>');
                    demobo.discovery.connectWIFIByCode(ipCode);
                    utils.saveDeviceInfo();
                } else {
                    var warning = "Please get onto the same WIFI<br>as your computer then restart.";
                    demobo.demoboCode.append('<div class="instruction">'+warning+'</div>');
                }
            }
        }.bind(this), 3000);
    }

    function initApp() {
        setTimeout(function(){
            if (navigator.splashscreen) navigator.splashscreen.hide();
            var mainContext = Engine.createContext();
            var mobileView = new MobileView();
            mainContext.add(mobileView);
        }.bind(this), 400);
    }

});
