cordova.define("demoboPlugin.demoboWebsocket", function(require, exports, module) { var startServer = function(str, successCallback, failCallback) {
    if(successCallback == undefined) successCallback = function(){};
    if(failCallback == undefined) failCallback = function(){};
    if (str == undefined)
        str = "";
    cordova.exec(successCallback, failCallback, "demoboPlugin", "startServer", [ str ]);
};

var stopServer = function(successCallback, failCallback) {
    if(successCallback == undefined) successCallback = function(){};
    if(failCallback == undefined) failCallback = function(){};
    cordova.exec(successCallback, failCallback, "demoboPlugin", "stopServer", [ "" ]);
};

var getURL = function(success, error) {
    cordova.exec(success, error, "demoboPlugin", "getURL", []);
};

function DemoboWebsocket(options) {
    this.channel = options.channel;
    this.id = options.id;
    this.isHost = options.isHost;
    this.port = options.port;
    this.internalIP = options.internalIP;
    if(this.isHost){
        stopServer();
        startServer(this.port);
    }
    setTimeout(this.init.bind(this), 1000);
    this.startServer = startServer;
    this.stopServer = stopServer;
}
DemoboWebsocket.prototype = Object.create(Object.prototype);
DemoboWebsocket.prototype.constructor = DemoboWebsocket;
DemoboWebsocket.prototype.init = function(){
    this.socket =  new WebSocket("ws://" + this.internalIP + ":" + this.port);
    this.socket.onmessage = this.socketonmessage;
    this.socket.onopen = this.socketonopen;
    this.socket.onclose = this.socketonclose;
};

DemoboWebsocket.prototype.send = function(message){
    if (this.socket) this.socket.send(JSON.stringify(message));
};
DemoboWebsocket.prototype.onMessage = function(callback){
    this.socketonmessage = function(evt) {
        callback(JSON.parse(evt.data));
    };
};
DemoboWebsocket.prototype.offMessage = function(){
    if (this.socket) delete this.socket.onmessage;
};

module.exports = DemoboWebsocket;
});
